; Video test for Fairchild Channel F v1.1
; color bars, chars, 4 x checkerboards, vertical rgb lines, vertical bw lines
; Use button "1" to cycle through
;
; frog@enlight.ru
; https://enlight.ru/roi

	processor f8

clrscrn	=	$00d0	; uses r31
delay	=	$008f
drawchar  = $0679	;	prints char r0 (code+color) at col r1, row r2

xc0			=	29	; chars x0
yc0			=	27	; chars y0 

x0	=	15
y0	=	10  
xs	=	6	
ys	=	6

	org	$800

cartridgeStart:
	.byte	$55, $2B					; cartridge header

cartridgeEntry:

; ================================= COLOR

AGAIN:

	li	$c6			; $21 - b/w palette, fill with black. $c6 - color palette, fill with gray
	lr	3, A
	pi	clrscrn		; clrscrn BIOS call


; draw several vertical bars

	li	$40	;r
	lr	1,a

	li	8+3	;x
	lr	6,a

	li	1	;y
	lr	3,a

	pi plotVertColorBar		; r1 - color, r6 - x, r1 - y

	li	$00	;r
	lr	1,a

	li	8*3+3	;x
	lr	6,a

	li	1	;y
	lr	3,a

	pi plotVertColorBar		; r1 - color, r6 - x, r1 - y

	li	$80	;r
	lr	1,a

	li	8*5+3	;x
	lr	6,a

	li	1	;y
	lr	3,a

	pi plotVertColorBar		; r1 - color, r6 - x, r1 - y

	li	$40	;r
	lr	1,a

	li	8*7+3	;x
	lr	6,a

	li	1	;y
	lr	3,a

	pi plotVertColorBar		; r1 - color, r6 - x, r1 - y

	li	$00	;r
	lr	1,a

	li	8*9+3	;x
	lr	6,a

	li	1	;y
	lr	3,a

	pi plotVertColorBar		; r1 - color, r6 - x, r1 - y

	li	$80	;r
	lr	1,a

	li	8*11+3	;x
	lr	6,a

	li	1	;y
	lr	3,a

	pi plotVertColorBar		; r1 - color, r6 - x, r1 - y

; ---------- horizontal bars

; set palette for line (y: r3)
;
; 00->125, 00->126: rgb, lightgreen back
; 00->125, ff->126: rgb, lightblue back
; ff->125, 00->126: rgb, transparent (gray) back
; ff->125, ff->126: www, black back

	li	8+4
	lr	3,a			; y

	li	$00			; color part 1
	lr	6, a

	li	$ff			; color part 2
	lr	4, a

	pi	plotHorizColorBar


	li	8*3+4
	lr	3,a			; y

	li	$ff			; color part 1
	lr	6, a

	li	$ff			; color part 2
	lr	4, a

	pi	plotHorizColorBar


	li	8*5+4
	lr	3,a			; y

	li	$00			; color part 1
	lr	6, a

	li	$00			; color part 2
	lr	4, a

	pi	plotHorizColorBar

;qq:
;	jmp qq	

	pi	readbuttons
;-============================================ DRAW CHARS ==============================================-

	li	$c6			; $21 - b/w palette, fill with black. $c6 - color palette, fill with gray
	lr	3, A
	pi	clrscrn		; clrscrn BIOS call


; first line
	li	x0			; x
	lr	1,a
	li	y0			; y
	lr	2,a
	li	$80	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	0			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*1			; x
	lr	1,a
	li	y0+ys*0			; y
	lr	2,a
	li	$80	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	1			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*2			; x
	lr	1,a
	li	y0+ys*0			; y
	lr	2,a
	li	$80	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	2			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*3			; x
	lr	1,a
	li	y0+ys*0			; y
	lr	2,a
	li	$80	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	3			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*4			; x
	lr	1,a
	li	y0+ys*0			; y
	lr	2,a
	li	$80	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	4			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*5			; x
	lr	1,a
	li	y0+ys*0			; y
	lr	2,a
	li	$80	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	5			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*6			; x
	lr	1,a
	li	y0+ys*0			; y
	lr	2,a
	li	$80	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	6			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*7			; x
	lr	1,a
	li	y0+ys*0			; y
	lr	2,a
	li	$80	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	7			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*8			; x
	lr	1,a
	li	y0+ys*0			; y
	lr	2,a
	li	$80	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	8			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*9			; x
	lr	1,a
	li	y0+ys*0			; y
	lr	2,a
	li	$80	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	9			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            


; second line
	li	x0			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	10			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*1			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	11			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*2			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	12			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*3			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	13			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*4			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	14			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*5			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	15			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*6			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	16			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*7			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	17			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*8			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	18			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*9			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	19			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*10			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	20			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*11			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	21			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*12			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	22			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*13			; x
	lr	1,a
	li	y0+ys*1			; y
	lr	2,a
	li	$c0	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	23			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

; ;third line

	li	x0+xs*0			; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	24			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*1		; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	25			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*2		; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	26			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*3		; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	27			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*4		; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	28			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*5		; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	29			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*6		; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	30			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*7			; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	31			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            
; next chars beyond of rom?
	li	x0+xs*8		; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	32			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*9		; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	33			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*10	; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	34			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*11	; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	35			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*12	; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	36			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            

	li	x0+xs*13	; x
	lr	1,a
	li	y0+ys*2			; y
	lr	2,a
	li	$40	; char color in bits 6,7: $80 (%10000000) - red, $c0 (%11000000) - green, $40 (%01000000) - blue, $00 (%00000000) - transparent?
	oi	37			; index of char ( e.g. 3 for "3" )
	lr	0,A		; combined color + char index -> r0
	pi	drawchar            



	pi	readbuttons


; draw checkerboard -----------------------------------------
; set bw pal
	li	$21			; $21 - b/w palette, fill with black. $c6 - color palette, fill with gray
	lr	3, A
	pi	clrscrn		; clrscrn BIOS call
; BW
	li	$00			; color
	lr	1, a
	pi drawcheckerboard

	pi	readbuttons

; set color pal
	li	$c6			; $21 - b/w palette, fill with black. $c6 - color palette, fill with gray
	lr	3, A
	pi	clrscrn		; clrscrn BIOS call
; R
	li	$00			; color
	lr	1, a
	pi drawcheckerboard

	pi	readbuttons
; G
	li	$40			; color
	lr	1, a
	pi drawcheckerboard

	pi	readbuttons
; B
	li	$80			; color
	lr	1, a
	pi drawcheckerboard


	pi readbuttons

; VERTICAL COLOR LINES ----------------------------


	li	$c6			; $21 - b/w palette, fill with black. $c6 - color palette, fill with gray
	lr	3, A
	pi	clrscrn		; clrscrn BIOS call


	li	61			; (r3) Y (most bottom)
	lr	3,a


nextline:

	li	4			; (r4) number of cwwwwww patterns perline
	lr	4,a

	li	101			; X (most right)
	lr	2, a
nextpattern:

; r1 = color  $00 = green, $40 = %01000000 = red, $80 = %10000000 = blue, $C0 = %11000000 = background
; r2 = x (to screen) (4-105) (0-101)
; r3 = y (to screen) (4-61) (0-57)

	li	$80	;b
	lr	1,a
	pi plotCOLORpattern

	li	$00	;g
	lr	1,a
	pi plotCOLORpattern

	li	$40	;r
	lr	1,a
	pi plotCOLORpattern

	ds	4			; r4--, next pattern
	bnz nextpattern

	ds	3			; r5--, next line
	bnz nextline


	pi readbuttons

; VERTICAL BW LINES ----------------------------


	li	$21			; $21 - b/w palette, fill with black. $c6 - color palette, fill with gray
	lr	3, A
	pi	clrscrn		; clrscrn BIOS call


	li	61			; (r3) Y (most bottom)
	lr	3,a


nextline2:

	li	13			; (r4) number of rgbw patterns perline
	lr	4,a

	li	101			; X (most right)
	lr	2, a
nextpattern2:

; r1 = color  $00 = green, $40 = %01000000 = red, $80 = %10000000 = blue, $C0 = %11000000 = background
; r2 = x (to screen) (4-105) (0-101)
; r3 = y (to screen) (4-61) (0-57)

	pi plotBWpattern

	ds	4			; r4--, next pattern
	bnz nextpattern2

	ds	3			; r5--, next line
	bnz nextline2

	pi	readbuttons





;again: 	jmp	again



	jmp	AGAIN

loop:	jmp	loop
; -=============================================== SUBROUTINES =====================================================-
;---------------;
; Plot Function, Original Version ;
;---------------;

; plot out a single point on the screen
; uses three registers as "arguments"
; r1 = color  $00 = green, $40 = %01000000 = red, $80 = %10000000 = blue, $C0 = %11000000 = background
; r2 = x (to screen) (4-105) (0-101)
; r3 = y (to screen) (4-61) (0-57)

plot:
	; set the color using r1
	lr	A, 1
	outs	1

	; set the column using r2
	lr	A, 2
	com
	outs	4

	; set the row using r3
	lr	A, 3
	com
	outs	5

	; transfer data to the screen memory
	li	$60
	outs	0
	li	$50
	outs	0

	; delay until it's fully updated
	lis	6
.plotDelay:	
	ai	$ff
	bnz	.plotDelay

	pop				; return from the subroutine



; --------------- COLOR vertical lines
; Plot several pixels in line
; rwwwwwwwgwwwwwwwbwwwwwww

; plot out a single point on the screen
; uses three registers as "arguments"
; r1 = color  $00 = green, $40 = %01000000 = red, $80 = %10000000 = blue, $C0 = %11000000 = background
; r2 = x (to screen) (4-105) (0-101)
; r3 = y (to screen) (4-61) (0-57)

plotCOLORpattern:
	; set the color using r1
	lr	A, 1
;	li	$80
	outs	1

	; set the column using r2
	lr	A, 2
	com
	outs	4

	; set the row using r3
	lr	A, 3
	com
	outs	5

	; transfer data to the screen memory
	li	$60
	outs	0
	li	$50
	outs	0

	; delay until it's fully updated
	lis	6
.plotDelay1:	
	ai	$ff
	bnz	.plotDelay1

	ds	2

; --
	li	7			; (r6) number of background dots
	lr	6,a

	; set the color using r1
	li	$c0
	outs	1

	; set the row using r3
	lr	A, 3
	com
	outs	5

nextBGdot:

	; set the column using r2
	lr	A, 2
	com
	outs	4

	; transfer data to the screen memory
	li	$60
	outs	0
	li	$50
	outs	0

	; delay until it's fully updated
	lis	6
.plotDelay4:	
	ai	$ff
	bnz	.plotDelay4

	ds	2

	ds	6

	bnz	nextBGdot


;	ds	2

	pop				; return from the subroutine

; -------------- BW vertical lines


; Plot several pixels in line
; rwwwwwwwgwwwwwwwbwwwwwww

; plot out a single point on the screen
; uses three registers as "arguments"
; r1 = color  $00 = green, $40 = %01000000 = red, $80 = %10000000 = blue, $C0 = %11000000 = background
; r2 = x (to screen) (4-105) (0-101)
; r3 = y (to screen) (4-61) (0-57)

plotBWpattern:
	; set the color using r1
;	lr	A, 1
	li	$40
	outs	1

	; set the column using r2
	lr	A, 2
	com
	outs	4

	; set the row using r3
	lr	A, 3
	com
	outs	5

	; transfer data to the screen memory
	li	$60
	outs	0
	li	$50
	outs	0

	; delay until it's fully updated
	lis	6
.plotDelay1b:	
	ai	$ff
	bnz	.plotDelay1b


	ds	2


; --
	li	7			; (r6) number of background dots
	lr	6,a

	; set the color using r1
	li	$c0
	outs	1

	; set the row using r3
	lr	A, 3
	com
	outs	5

nextBGdotB:

	; set the column using r2
	lr	A, 2
	com
	outs	4

	; transfer data to the screen memory
	li	$60
	outs	0
	li	$50
	outs	0

	; delay until it's fully updated
	lis	6
.plotDelay4b:	
	ai	$ff
	bnz	.plotDelay4b

	ds	2

	ds	6

	bnz	nextBGdotB


;	ds	2

	pop				; return from the subroutine


; R1 - color
drawcheckerboard:
	lr k,p 			; we have to save pc because of nested subroutine call

	clr
	lr	8,a			; 0-> r8. (r8 used to flip bit 0/1)

	li	2			; shift (0|1)
	lr	5, a

	li	54			; (r4) number of iterations (ysize)
	lr	4,a			; a->r4


nextln:

	lr	a,4			; load y0
	ai	5			; a+const->a  (y0)
	lr	3, a

	li	50			; related to xsize
	lr	7,a			; (r7) number of iterations (x)

; xor r8 with 1 (flip 1 <-> 0)
	li	1
	xs	8				; a xor r8 -> a
	lr	8,a

; r8 + 42 -> r2
	li	103			; related to x0 WAS:42
	as	8			; x = x+y (shift by 1 pixel) 
	lr	2,a			; (r2) coord (x)


; draw dotted line
nextpx:

; smart color
;	lr	a,4
;	as	2
;	li	$80			; color ($00, $40, $80)
;	lr	1,a

	pi plot			; r1 - color, r2 - x, r3 - y  (a,r6 also lost)

	ds	2			; r2-- (coord)
	ds	2			; r2-- (coord)

	ds	7			; r7-- (number of iterations)
	bnz nextpx		; until r7 = 0


	ds	4			; r4--
	bnz nextln		; until r2 = 0

	pk

; --------------------- wait for button
readbuttons:       
	ins  0                   ; $00c1 - read buttons
	com                       
	ni   $0f                 
	bt   4,readbuttons          
	lr   $4,a                 
	li   $ff                  
	lr   $5,a                 
debounce:       
	ds   $5                   
    bnz  debounce          
	pop


; -------------------------- vertical thick bars



; Plot several pixels in line
; rwwwwwwwgwwwwwwwbwwwwwww

; plot out a single point on the screen
; uses three registers as "arguments"
; r1 = color  $00 = green, $40 = %01000000 = red, $80 = %10000000 = blue, $C0 = %11000000 = background
; r6 = x (to screen) (4-105) (0-101)
; r3 = y (to screen) (4-61) (0-57)

plotVertColorBar:

	li	61		; rows (height)
	lr	5,a

nextrow:

	li	8		; columns (width)
	lr	4,a

	lr	a,6
	lr	2,a
nextcol:
	; set the color using r1
	lr	A, 1
	outs	1

	; set the column using r2
	lr	A, 2
	com
	outs	4

	; set the row using r3
	lr	A, 3
	com
	outs	5

	; transfer data to the screen memory
	li	$60
	outs	0
	li	$50
	outs	0

	; delay until it's fully updated
	lis	6
.plotDelay5:	
	ai	$ff
	bnz	.plotDelay5

	lr	a,2
	inc
	lr	2,a

	ds	4
	bnz	nextcol

	
	lr	a,3
	inc
	lr	3,a

	ds	5
	bnz	nextrow


	pop				; return from the subroutine

; ----------------- draw horizontal bar

plotHorizColorBar:

	lr k,p 			; we have to save pc because of nested subroutine call

	li	8			; height
	lr	5,a

nextrow2:

	lr	a,6			; color
	lr	1, a

	li	125			; x125
	lr	2, a

	pi plot

	lr	a,4			; color
	lr	1, a

	li	126			; x126
	lr	2, a

	pi plot

	lr	a,3			; y++
	inc
	lr	3,a

	ds	5
	bnz	nextrow2

	pk				; return from subroutine level 1

    org $fff        ; added only to set a useable rom-size in MESS
    .byte   $ff
